#!/usr/bin/perl


# Prvenir domos.homelinux@wanadoo.fr
# quand le driver marchera sur port //
BEGIN
{
	push @INC, ".";
	$ENV{PATH}	.= "./";
}



package i2c;

# Lib perso
# Non distribu
# use getone; # ATTENTION, placer avant le use Device*
#require "misc.pm";

use strict;
use diagnostics;
use Time::HiRes qw(usleep);
#sub usleep { return; for (my $i=0; $i < 100; $i++) {} }

# Appel d'originede SerialPort, modife pour qu'il soit transportable.
#use Device::SerialPort qw(  :PARAM :STAT 0.07 );
use SerialPort qw(  :PARAM :STAT 0.07 );

my ($sda)	= 0;
my ($scl)	= 0;
$::I2C_TIMEOUT	= 100000;
$::I2C_OK	= 0;
$::CONV_DELAY	= 500;
@::BUF		= ();

my (@ME)	= ("test", "i2csh", "scani2c", "showtemp");

&setup();

sub setup
{
   use File::Basename;
   my ($cmd)	= basename( $0 );
   my ($o)	= "";

   RETa: foreach my $tmp (@ME)
   {
      if ($cmd eq $tmp)
      {
         $o = new i2c("/dev/ttyS1");
         #no strict;
         $o -> ${tmp} ( join(" ", @ARGV) ) ;
         #use strict;
         last RETa;
      }
   }
}

sub new
{
    my ($cl)	= shift;
    my ($arg)	= shift;

    my ($class)	= {};
    bless $class, ref($cl) || $cl;

    $class->{cfg}->{device}	= $arg;
    $class->{serial} = Device::SerialPort ->new($arg) || die "Can't open $arg: $!\n";

    $class->{CMD}	= 0;
    $class->{ADR}	= 1;
    $class->{ARG_READ}	= 2;
    $class->{ARG_WRITE}	= 2;

    $class->{return} = "";

    return( $class );

}

sub init
{
# INIT I2C
    my ($obj)	= shift;
    $scl = $sda = 1;
    #$ser->dtrrts_active( $sda, $scl  );
    $obj->set( $scl, $sda  );
    #usleep (100000);
    #die (" init wbyte timeout\n") if (&wbyte( 0xFF ) == $::I2C_TIMEOUT);
    $obj->wbyte( 0xFF );
    $obj->end();
       #printf("ressor de CL\n");

    if ($obj->wait_free())
    {
       printf STDERR ("init(): Bus error\n");
       return ( $::I2C_TIMEOUT );
    }
    return( $::I2C_OK );
}



sub reinit
{
    my ($obj)	= shift;
    $scl = $sda = 1;
    $obj->set($scl, $sda);
    $obj->wbyte(0x00);
    $obj->end();
    return($::I2C_TIMEOUT) if ($obj->wait_free() );
    return (0);
}

sub set
{
    my ($obj)	= shift;
    my ($scl)	= shift;
    my ($sda)	= shift;
    $obj->{return} = "";

    #printf("SCL=%s   SDA=%s\n", $scl, $sda);
    $scl ^= 1;
    $sda ^= 1;
    #printf("SCL=%s   SDA=%s INVERT\n", $scl, $sda);
    return($obj->{serial}->dtrrts_active( $scl, $sda  ) );
    #return($device->dtrrts_active( $scl, $sda  ) );
}

sub get
{
    my ($obj)	= shift;
    $obj->{return} = "";
    #my ($scl)	= shift;
    #my ($sda)	= shift;
    #($scl, $sda) = $device->dsrcts_status();
    ($scl, $sda) = $obj->{serial}->dsrcts_status() ; # return dsr, cts
    #$scl ^= 1;
    #die"SD\n\n" unless (defined($sda));
    #printf("SDA: %d, SCL: %s\n", $sda, $scl);
    $sda = 1 ^ $sda;
    return ($scl, $sda);
    #return($obj->{serial}->dsrcts_status()) ; # return dsr, cts

}

sub start
{
    my ($obj)	= shift;
     $scl = $sda = 1;
     $obj->set($scl, $sda);
     return( $::I2C_TIMEOUT ) if ( $obj->wait_free() );
     $sda = 0;
     $obj->set($scl, $sda);
     $scl = 0;
     $obj->set($scl, $sda);
     return ( $::I2C_OK );
}

sub stop
{
    my ($obj)	= shift;
    $sda = 0;
    $obj->set($scl, $sda);
    $scl = 1;
    $obj->set($scl, $sda);
    return( $::I2C_TIMEOUT ) if ( $obj->waitcl() );
    $sda = 1;
    $obj->set($scl, $sda);
    return( $::I2C_OK );
}

sub end
{
    my ($obj)	= shift;
    my ($i)	= 0;

    $sda = 0;
    $obj->set($scl, $sda);
    $scl = 1;
    $obj->set($scl, $sda);

    return $::I2C_TIMEOUT if ( $obj->waitcl() );
    $sda = 1;
    $obj->set($scl, $sda);

    for(my $i = 0; $i < 7; $i++)
    {
       $scl = 0;
       $obj->set($scl, $sda);
       $scl = 1;
       $obj->set($scl, $sda);
       return $::I2C_TIMEOUT if ( $obj->waitcl() );
    }

    return( $::I2C_OK );
}

sub read
{
    #my ($obj)	= shift;
    my ($obj)	= shift;
    my ($adr)	= shift;
    #my ($uf)	= shift;
    my ($count)	= shift;

    my ($ack)	= 0;
    #my @buf = ();
    #*buf = *uf;
    @::BUF	= ();

    $count = 1 unless(defined($count));
    $count = 1 if( $count < 1);
    $obj->{return} = "";

    $obj->start();
    $ack = $obj->wbyte( ($adr & 254) + 1);
    if ($ack)
    {
       $obj->stop();
       printf("(&read) Wrong address: 0x%02x\n", ($adr & 254) +1);
       $obj->{return} = ($ack << 8);
       return ( undef );
    }

    for (my $i=0; $i < $count; $i++)
    {
       #$::BUF[ $i ] = $obj->rbyte();
       $::BUF[ $i ] = $obj->rbyte();
       if ($i < $count - 1) { $obj->ack(); }
       else { $obj->nack(); }
    }
    $obj->stop();

    $obj->{return} = ($ack << 8)| $count;
    return( \@::BUF );
}

sub write
{
    #my ($obj)	= shift;
    my ($obj)	= shift;
    my ($adr)	= shift;
    my ($buf)	= shift;
    my ($count)	= shift;

    my ($ack)	= 0;
    @::BUF	= @$buf;
    $obj->{return} = "";

    $count = $#::BUF unless (defined($count) );
    $count = 1 if( $count < 1);


    $obj->start();
    $ack = $obj->wbyte( ($adr & 254));
    if ($ack)
    {
       $obj->stop();
       printf("(&write) Wrong address: 0x%02x\n", ($adr & 254) +1);
       return ( $ack );
    }

    for (my $i=0; $i < $count; $i++)
    {
       $ack = $obj->wbyte( $::BUF[ $i ]);
       if ($ack)
       {
          $obj->stop();
          printf("&write: Write error '%s'\n", $adr & 254 );
          $obj->{return} = $ack;
          # 0 for error.
          return( 0 );
       }
    }
    $obj->stop();

    # Return number byte writing.
    $obj->{return} = ($ack << 8)| $count;
    return( $obj->{return} );

}

sub ack
{
    my ($obj)	= shift;
    $scl = 0;
    $obj->set($scl, $sda);

    $sda = 0;
    $obj->set($scl, $sda);

    $scl = 1;
    $obj->set($scl, $sda);
    return ($::I2C_TIMEOUT) if ( $obj->waitcl() );

    $scl = 0;
    $obj->set($scl, $sda);

    return( $::I2C_OK );
}

sub nack
{
    my ($obj)	= shift;
    $scl = 0;
    $obj->set($scl, $sda);

    $sda = 1;
    $obj->set($scl, $sda);

    $scl = 1;
    $obj->set($scl, $sda);
    return ($::I2C_TIMEOUT) if ( $obj->waitcl() );

    $scl = 0;
    $obj->set($scl, $sda);

    return( $::I2C_OK );
}

sub rbyte
{
    my ($obj)	= shift;
    #my ($obj)	= shift;
    my ($byte)	= 0;
    my ($cl)	= 0;
    my ($dat)	= 0;

    $obj->{return} = "";
    for(my $i = 0; $i <=7 ; $i++)
    {
       $scl = 0; $sda = 1; $obj->set($scl, $sda);
       $scl = 1; $obj->set ($scl, $sda);
       return ($::I2C_TIMEOUT) if ( $obj->waitcl() );

       ($cl, $dat) = $obj->get();

       $byte = ( ($byte) << 1 ) + ($dat > 0);
    }
    return( $byte );
}

sub wbyte
{
    my ($obj)	= shift;
    my ($byte)	= shift; # (char byte)
    my ($cl)	= 0;
    my ($dat)	= 0;

    my ($b)	= 128;
    $obj->{return} = "";

    for(my $i = 0; $i <=7 ; $i++)
    {
       $sda = (( $byte & $b) != 0);
       $obj->set($scl, $sda);
       $scl = 1;
       $obj->set($scl, $sda);
       return ($::I2C_TIMEOUT) if ( $obj->waitcl() );
       #printf("IInb:byte  %s:%s scl=%s bute&j=%s\n", $i, $byte, $scl, $sda);
       $scl = 0;
       $obj->set($scl, $sda);

       $b = $b >> 1;
    }
    #$scl = 0;
    $sda = 1;
    $obj->set($scl, $sda);
    $scl = 1;
    $obj->set($scl, $sda);
    return ($::I2C_TIMEOUT) if ( $obj->waitcl() );
    ($cl, $dat) = $obj->get();
    $scl = 0; 
    #$sda = 1;
    $obj->set($scl, $sda);

    #warn"ok: $dat";
    return($dat);
}

sub wait_free
{
    my ($obj)	= shift;
    my ($cl)	= 0;
    my ($dat)	= 0;
    my ($timeout)	= $::I2C_TIMEOUT;

    while( (($cl == 0) || ($dat == 0)) && ($timeout) ) 
    {
       #($cl, $dat) = $obj->{serial}->dsrcts_status();
       ($cl, $dat) = $obj->get();
       #($cl, $dat) = $device->dsrcts_status();
       $timeout--;
       printf("wait_free, cl=%d, dat=%d, timeout=%d\n", $cl, $dat, $timeout);
        #die("jojojo") if ($cl == 1);
    }

    return $::I2C_OK if ($timeout);
    #die("TIMEOUT\n\n");
    return $::I2C_TIMEOUT;
}

sub waitcl
{
    #my ($class)	= shift;
    my ($obj)	= shift;
    my ($cl)	= 0;
    my ($dat)	= 0;
    my ($timeout)	= $::I2C_TIMEOUT;

    while( ($cl == 0) && $timeout) 
    {
       #printf("cl=\n", $cl, $dat);
       ($cl, $dat) = $obj->get();
       #printf("cl=%s, dat=%s\n", $cl, $dat);
       $timeout--;
    }
    #printf("cl=%s, dat=%s, timeout=%s\n", $cl, $dat, $timeout);

    #printf("TIM: $timeout\n");
    return($::I2C_OK) if ($timeout);
    #idie("TIMEOUT in &waitcl\n");
    return($::I2C_TIMEOUT);
}

########################################################################
########################################################################
########################## COMMANDES ###################################
########################################################################
########################################################################

#package i2ctools;

sub showtemp
{
    my ($obj)	= shift;
    my ($adr)	= 0x90;
    my ($delay)	= $::CONV_DELAY * 1000;
    my ($flag)	= 128;
    my (@buf)	= ();

    if ( $obj->init(0) )
    {
       printf STDERR ("Unable to initialize I2C bus\n");
       exit (-1);
    }

    $buf[0] = 0xAC;
    $buf[1]	= 1;
    #$obj->wr ($adr, \@buf, 2);
    $obj->write ($adr, \@buf, 2);
    
    # Start temperature
    @buf = ( 0xEE, 1 );
    $obj->write ($adr, \@buf, 2);
    usleep( $delay );

    do
    {
       $buf[0]	= 0x22;
       $obj->write($adr, \@buf, 1);

       $buf[0]	= 0xAA;
       $obj->write($adr, \@buf, 1);

    } while( 0);
    

die ("Showtemp pas termin\n");
exit;

}

sub testi2c
{
    my ($obj)	= shift;
    my ($adr)   = shift;
    my ($ret)   = 0;
    $obj->start();
    $ret = $obj->wbyte( ( $adr & 254 ) + 1 );
    $obj->stop();
    if ( $ret == $::I2C_TIMEOUT)
    {
       $obj->reinit();
    }
    return( $ret );
}

sub i2csh
{
    my ($obj)	= shift;
    my ($arg)	= shift;

    my (@arg)	= ();
    my (@buf)	= ();
    my (@nia)	= ();
    my ($delay)	= $::CONV_DELAY * 1000;
    my ($countr)	= 1;
    my ($countw)	= 1;
    my ($adr)	= 0;

    #$arg = ("w 4e 1");
    #$arg = ("r 4e 1");

    return(-1) unless (defined($arg));
    while($arg =~ s/  / /g) {}
    @arg	= split(/ /, $arg);

    if ( $obj->init(0) )
    {
       printf STDERR ("Unable to initialize I2C bus\n");
       exit (-1);
    }
    usleep (500000);

    foreach (my $i = 0; $i <= $#arg; $i++)
    {
       #printf STDERR ("Arg: -%s-\n", $arg[ $i ]);
       $_ = lc($arg[ $i ]);
       
       if ( (/w/ || /r/) && defined($buf[0]) )
       {
          if ( $#buf == 0)
          {
             printf STDERR ("2nd Arguements isnt'n numeric\n");
             exit(-1);
          }
          else
          {
             push @nia, [@buf];
             @buf = ();
          }
       }



       if (/^w$/)
       {
          #printf("Write: ");
          #push @buf, $arg[$i];
          #&wr($
          #die("lll");
       }
       elsif (/^r$/)
       {
          #printf("Read: ");
       }
       elsif (/^wr$/ || /^rw$/ )
       {
          #printf("Write/Read: ");
       }
       else
       {
          
          $_ = &unbase($_, 16);
          #printf("r: %s\n", $_);
          #die ("okkkkkkkkkk $_ kkkkkkkkkkkkkkkkkkkkk") if($_ == 0x4e);
       }
       push @buf, $_;
    }

    push @nia, [@buf] if ( $#buf >= 0);

    @buf	= ();

    foreach my $tmp (@nia)
    {
       $_ = $tmp->[ $obj->{CMD} ];
       $adr = $tmp->[$obj->{ADR}];

       if (/^w$/)
       {
          $obj->mewrite($adr, $tmp);
        if (0)
        {
          shift( @$tmp);
          shift( @$tmp);
          $countw	= $#$tmp + 1;
          printf("_Write: $adr, %s\n", $#$tmp);
          $obj->write( $adr, \@$tmp, $countw );

          if ( $countw != $obj->{return})
          {
             # On informe que l'criture effectue par &write est
             # diffrente de celle demand dans $count...
             printf("WARNING: &i2csh writing error &write(%s) return '%s'...\n", $countw, $obj->{return});
          }


          printf("&Write( 0x%02x) => %sd\n", $adr, $countw);
        }
       }
       elsif (/^r$/)
       {
          @buf = @{ $obj->meread($adr, $countr) };
        if (0)
        {
          $countr	= $tmp->[ $obj->{ARG_READ} ];
          @buf		= @{$obj->read( $adr, $countr )};

          if ($countr != $obj->{return})
          {
             # On informe que la lecture effectu par &read est
             # diffrente de celle demand dans $count...
             printf("WARNING: &i2csh reading error &read(%s) return '%s'...\n", $countr, $obj->{return});
          }


          printf("Read( 0x%02x, %s) =>", $adr, $countr);
          foreach my $tmp2 ( @buf) { printf(" %s", $tmp2); }
          print ("\n");
          }

       }
       elsif (/^wr$/ || /^rw$/ )
       {
          $countr	= $tmp->[ $obj->{ARG_READ} ];

          # WRITE
          $obj->mewrite($adr, $tmp);
          @buf = @{ $obj->meread($adr, $countr) };


       }

       #foreach my $pmt (@$tmp) { printf(">%s ", $pmt); } printf "\n";
    }
    
}

sub mewrite
{
    my ($obj)	= shift;
    my ($adr)	= shift;
    my ($tmp)	= shift;
    my ($countw)	= 0;
          shift( @$tmp);
          shift( @$tmp);
          #shift( @$tmp);
          $countw	= $#$tmp + 1;
          #printf("_Write: $adr, %s\n", $#$tmp);
          $obj->write( $adr, \@$tmp, $countw );

          if ( $countw != $obj->{return})
          {
             # On informe que l'criture effectue par &write est
             # diffrente de celle demand dans $count...
             printf("WARNING: &i2csh writing error &write(%s) return '%s'...\n", $countw, $obj->{return});
          }
          printf("&Write( 0x%02x) %s bytes (decimal)\n", $adr, $countw);

}

sub meread
{
    my ($obj)	= shift;
    my ($adr)	= shift;
    my ($countr)	= shift;
          # READ

          #my (@buf)	= @{$obj->read( $adr, $countr )};
          my (@buf)	= @{$obj->read( $adr, $countr )};

          # On informe que la lecture effectu par &read est
          # diffrente de celle demand dans $count...
          printf("WARNING: &i2csh reading error &read(%s) return '%s'...\n",
             $countr, $obj->{return})
               if ($countr != $obj->{return});


          printf("&Read ( 0x%02x) %s bytes (decimal)\n", $adr, $countr);
          foreach my $tmp2 ( @buf) { printf(" %02X", $tmp2); }
          print ("\n");


    return( \@buf );
}

sub scani2c
{
    my ($obj)	= shift;
    my ($adr)	= 0x92;
    my ($delay)	= $::CONV_DELAY * 1000;
    my ($flag)	= 128;
    my (@buf)	= ();

    if ( $obj->init(0) )
    {
       printf STDERR ("scani2c: Unable to initialize I2C bus\n");
       exit (-1);
    }
    usleep (500000);
    printf("Addresse probing ...\n");

    for (my $ad=0x0; $ad <= 256; $ad += 2)
    {
        $flag = $obj->testi2c( $ad );

        if ($flag == $::I2C_TIMEOUT )
        {
            printf("!x!! ", $ad);
        }
        elsif($flag == $::I2C_OK)
        {
           #printf("0x%x: alive, ", $ad);
           printf("0x%x ", $ad);
        }
        else
        {
           printf("__ ", $ad);
        }
    }

    


}

# Test RTS and CTS signal
sub test
{
    my ($obj)	= shift;

    my (%on)	= (
                    "0",	"off",
                    "1",	"on",
                  );

   my $char;
   my ($flag)	= 0;
   my ($dtr)	= 1;
   my ($rts)	= 1;
   my ($d);
   my ($r);

   #Version avec getone:
   #my $o = new getone();

   printf("TESTer le bus I2C

Pour modifier les signaux DTR (scl) et RTS (sda) du port srie
Appuyez sur les touches :
   'd' pour modifier le status DTR (scl)
   'r' pour modifier le status ETS (sda)
   <!> Chaque changement inverse le bit avec un XOR, donc soit 0 ou 1

   'i' pour afficher l'tat du bus I2C
   'CTRL+c' pour terminer le test.
 ");
# Version avec getone.pm   'entre | return' pour terminer le test.


   #while( ($char = $o->get) ne "return")
   #while( 1 )
   while( ($char = <STDIN> ) ne "return")
   {
       chop ($char); # Activ quand getone.pm est dsactiv.

       if ($char eq "d")
       {
          $dtr = $dtr ^ 1;
       }
       elsif ($char eq "r")
       {
          $rts = $rts ^ 1;
       }
       elsif ($char eq "i")
       {
          ($d, $r) = $obj->get();
          #($d, $r) = $ser->dsrcts_status();
          printf("dtr=%d rts=%d (INFO)\n", $d, $r);
       }
       elsif ($char eq "return")
       {
           return (0);
       }
          printf("DTR %d RTS %d\n", $dtr, $rts );
          #$ser->dtrrts_active( $dtr, $rts );
   $obj->set($dtr, $rts);
   }
}



sub method_yail
{
    my ($obj)	= shift;
    my ($portserial)	= shift;
    my ($sfd)	= new_from_fd IO::Handle ($portserial, "r");
    my ($flag)	= 0;
    sub TIOCMGET { 0x0;}

# TIOCM_[DTR|RTS|CTS|DSR|CD]
    if (ioctl($sfd, {TIOCMGET}, $flag) == -1)
    {
       printf("Hola: %d\n", $flag);
    }
    else
    {
       printf("yes: %s\n", $flag);
    }
}

sub unbase
{
    my ($h)	= shift;
    my ($base)	= shift;

    # For test ...
    #$base  = 16;
    #$h = "fffffF";
    #$base  = 62;
    #$h = "ZZ";

    $h =~ s/ //g;
    $h =~ s/\0//g;
    my ($c)	= '';
    my ($lc)	= "";
    my ($len)	= length($h);
    my ($v)	= 0;

    $base = 16 unless (defined($base) );
    if ($base > 36  && $base <= 62)
    {
       $lc	= "no";
    }
    else
    {
       $h = lc( $h );
    }

    my (%h)	= ();
    my ($a)	= 'a';


    for(my $i=10; $i <= ($base - 1); $i++)
    {
       $h{$a} = $i;
       if ($a eq 'z' && $base > 36)
       {
          $a = 'A';
       }
       else
       {
          $a++;
       }
    }

    #use Math::BigInt;
    #$v = Math::BigInt->new('');
    $len --;
    for (my $i=0; $i <= ($len - 0); $i++)
    {
       $c = substr($h, ($len - 0)  - $i, 1);

       #printf("C:> %s:%s-%s-> %s == %d\n", $i, $i, $len, $h{'$c'}  );
       if ( $h{$c} )
       {
          $v = $h{$c} * ($base**$i) + $v; # plus visuel que ... += ...
       }
       elsif ( $c =~ /[0-9]/ )
       {
          $v = $c * ($base**$i) + $v; # plus visuel que ... += ...
       }
       else
       {
          #die("\nFA${c}UX!!!!\n");
          warn ("Bad char '$c', calcul continue...");
          #return(-1);
       }
    }
    #printf("A: -%s- %s\n", $v, $h{a} );
    return ( $v );
}



1;
